#include "yksikot.hh"
#include "yksikko.hh"

Yksikot::Yksikot()
{
	// si_3 jos eteen saa liitt SI-etuliitteen.
	add("m",  'm', si_c);
	add("V",  'V', si_3);
	add("J",  'J', si_3);
	add("A",  'A', si_3);
	add("W",  'W', si_3);
	add("g",  'g', si_3); // gramma. pit olla 'g'.
	add("l",  'l', si_c);
	add("N",  'N', si_3);
	add("K",  'K'); // Kelvin
	add("ohm",'O', si_3); // Ohmi
	add("S",  'S'); // Siemens
	add("F",  'F', si_3);
	add("H",  'H', si_3);
	add("C",  'C', si_3);
	add("s",  's', si_3);
	add("h",  'h');
	add("i",  'i'); // Imaginriyksikk! Pit olla 'i'.
	add("C", 'c'); // Ei kytss. Pelkstn laskentahilu...
	add("Pa", 'P', si_3);
	add("bar",'B', si_3);
	add("Hz", 'z', si_3);
	add("cd", 'd'); // Kandela (valovoima)
	add("mol",'o'); // Mooli
	add("toe",'t');
	add("'", '\''); // feet
	add("\"", '"'); // inch
	add("lbs",'b'); // 45.36
/* -- jtetn pois, sekaantuu vuorokausiin
	add("d",  'D'); // dioptri (linssin taittokyky)
*/
	add("lx", 'x'); // luksi (valaistusvoimakkuus)
	add("",  ''); // plusminus ei varsinaisesti ole
	                // yksikk, mutta olkoon tll
}

void Yksikot::add(const string &s, char c, si_case si)
{
	map<string,char>::operator[] (s) = c;
	cs[c] = pair<string, si_case> (s,si);
}

Yksikkomuunnokset::Yksikkomuunnokset(Yksikot &Yksikot)
{
	tulop tmp;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["m"]),  1);
	tmp->insert(new yksikko(Yksikot["'"]), -1);
	(*this)[tmp] = 2.54*12;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["g"]),   1);
	tmp->insert(new yksikko(Yksikot["lbs"]),-1);
	(*this)[tmp] = 45.36;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["m"]),  1);
	tmp->insert(new yksikko(Yksikot["\""]),-1);
	(*this)[tmp] = 2.54;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["V"]), 1);
	tmp->insert(new yksikko(Yksikot["A"]), 1);
	tmp->insert(new yksikko(Yksikot["W"]), -1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["A"]),   1);
	tmp->insert(new yksikko(Yksikot["ohm"]), 1);
	tmp->insert(new yksikko(Yksikot["V"]),  -1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["N"]),  1);
	tmp->insert(new yksikko(Yksikot["m"]),  1);
	tmp->insert(new yksikko(Yksikot["J"]), -1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["W"]),  1);
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	tmp->insert(new yksikko(Yksikot["J"]), -1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["g"]),  1);
	tmp->insert(new yksikko(Yksikot["m"]),  1);
	tmp->insert(new yksikko(Yksikot["s"]), -2);
	tmp->insert(new yksikko(Yksikot["N"]), -1);
	(*this)[tmp] = 0.001;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["m"]),  3);
	tmp->insert(new yksikko(Yksikot["l"]), -1);
	(*this)[tmp] = 1000;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["N"]),  1);
	tmp->insert(new yksikko(Yksikot["m"]), -2); /* Vai -3? Minusta -2, pinta-alalle */                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
	tmp->insert(new yksikko(Yksikot["Pa"]),-1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["J"]),    1);
	tmp->insert(new yksikko(Yksikot["toe"]), -1);
	(*this)[tmp] = 40.6E9;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["Pa"]),  1);
	tmp->insert(new yksikko(Yksikot["bar"]),-1);
	(*this)[tmp] = 100000;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["Hz"]), 1);
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["ohm"]),1);
	tmp->insert(new yksikko(Yksikot["S"]),  1);
	(*this)[tmp] = 1;
/*	tmp = new tulo; -- jtetn pois, sekaantuu vuorokausiin
	tmp->insert(new yksikko(Yksikot["d"]),  1);
	tmp->insert(new yksikko(Yksikot["m"]), -1);
	(*this)[tmp] = 1;
*/	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["C"]),  1);
	tmp->insert(new yksikko(Yksikot["V"]), -1);
	tmp->insert(new yksikko(Yksikot["F"]), -1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["V"]),  1);
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	tmp->insert(new yksikko(Yksikot["A"]), -1);
	tmp->insert(new yksikko(Yksikot["H"]), -1);
	(*this)[tmp] = 1;
/*	tmp = new tulo; -- onkos tm aivan oikein?
	tmp->insert(new yksikko(Yksikot["J"]),  1);
	tmp->insert(new yksikko(Yksikot["C"]), -1);
	tmp->insert(new yksikko(Yksikot["V"]), -1);
	(*this)[tmp] = 1;
*/	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["A"]),  1);
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	tmp->insert(new yksikko(Yksikot["C"]), -1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["Hz"]),  1);
	tmp->insert(new yksikko(Yksikot["H"]),   1);
	tmp->insert(new yksikko(Yksikot["ohm"]),-1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["Hz"]), -1);
	tmp->insert(new yksikko(Yksikot["F"]),  -1);
	tmp->insert(new yksikko(Yksikot["ohm"]),-1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["s"]),  1);
	tmp->insert(new yksikko(Yksikot["h"]), -1);
	(*this)[tmp] = 3600;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["s"]),   1);
	tmp->insert(new yksikko(Yksikot["H"]),  -1);
	tmp->insert(new yksikko(Yksikot["ohm"]), 1);
	(*this)[tmp] = 1;
	tmp = new tulo;
	tmp->insert(new yksikko(Yksikot["F"]),   1);
	tmp->insert(new yksikko(Yksikot["s"]),  -1);
	tmp->insert(new yksikko(Yksikot["ohm"]), 1);
	(*this)[tmp] = 1;
}
