#ifndef bqYksikOt_hh
#define bqYksikOt_hh

#include <map>
#include <string>

#include "tulo.hh"

class Yksikot : public map<string, char>
{
public:
	enum si_case { no_si=0, si_3=1, si_c=2 };
private:
	typedef map<char, pair<string, si_case> > cstype;
	cstype cs;
	void add(const string &s, char c, si_case si=no_si);
public:
	Yksikot();
	bool has(char c) { return cs.find(c) != cs.end(); }

	const string &operator[] (char c) const { return cs.find(c)->second.first; }
	inline char operator[] (const string &s) const { return find(s)->second; }
	
	unsigned Test(const string &s, unsigned pos=0)
	{
		unsigned ble=0;
		const_iterator i;
		for(i=begin(); i!=end(); ++i)
			if(i->first.size() >= ble && s.substr(pos, i->first.size()) == i->first)
				ble = i->first.size();
		return ble;
	}
	char Value(const string &s, unsigned pos=0)
	{
		unsigned ble=0;
		const_iterator i, j=end();
		for(i=begin(); i!=end(); ++i)
			if(i->first.size() >= ble && s.substr(pos, i->first.size()) == i->first)
			{
				ble = i->first.size();
				j = i;
			}
		return j->second;
	}
	si_case SI(char c) const
	{
		return cs.find(c)->second.second;
	}
};

class Yksikkomuunnokset : public map<tulop, real>
{
public:
	Yksikkomuunnokset(Yksikot &Yksikot);
};

#endif
